/*
 * common.h
 */

#ifndef __COMMON_H__
#define __COMMON_H__ 1

/*
 * ANSI-C stuff.  Snarfed from xloadimage.
 */

#ifdef __STDC__

#if !defined(_ArgProto)
#define _ArgProto(ARGS) ARGS
#endif

#else /* !__STDC__ */

#if !defined(const) /* "const" is an ANSI thing */
#define const
#endif
#if !defined(_ArgProto)
#define _ArgProto(ARGS) ()
#endif

#endif /* __STDC__ */

/*
 * If you have an old version of C++ without bool, you'll have to add
 * the ifdef here
 */
#ifndef __cplusplus

#if !defined(bool_DEFINED) && !defined(true_DEFINED) && !defined(false_DEFINED)
#define bool_DEFINED 1
#define true_DEFINED 1
#define false_DEFINED 1
typedef enum
{
  false = 0,
  true = 1
} bool;
#endif

#ifndef bool_DEFINED
#define bool_DEFINED 1
typedef int bool;
#endif

#ifndef true_DEFINED
#define true_DEFINED 1
#define true 1
#endif

#ifndef false_DEFINED
#define false_DEFINED 1
#define false 0
#endif

#endif /* __cplusplus */

#ifndef MAX
#define MAX(a,b) ((a) < (b) ? (b) : (a))
#endif
 
#ifndef MIN
#define MIN(a,b) ((a) < (b) ? (a) : (b))
#endif

/*
 * should be in limits.h
 */
#ifndef CHAR_BITS
#define CHAR_BITS 8
#endif

#ifndef byte_DEFINED
#define byte_DEFINED 1
typedef unsigned char byte;
#endif

#ifndef word_DEFINED
#define word_DEFINED 1
typedef unsigned long word;
#endif

void free_mem _ArgProto((void *));
void *alloc_mem _ArgProto((int));
void *calloc_mem _ArgProto((int, int));
void *realloc_mem _ArgProto((void *, int));
char *alloc_string _ArgProto((char *));

typedef struct _stringdb
{
  char *name;
  char *value;
  struct _stringdb *next;
} StringDB;

void AddListToStringDB _ArgProto((StringDB *));
void AddToStringDB _ArgProto((char *, char *));
char *GetFromStringDB _ArgProto((char *));
char *NGetFromStringDB _ArgProto((char *));
void AddLanguage _ArgProto((char *));

char *FixFilename _ArgProto((char *));
int SaveData _ArgProto((char *, int, char *));
void StartReaper();
char *mystrtok _ArgProto((char *, int, char **));
char *CreateCommandLine _ArgProto((char *, char *, char *));
char *EscapeHTML _ArgProto((char *));
int strsize _ArgProto((char *));

#endif /* __COMMON_H__ */
