/*
 * pnm.h
 *
 * Copyright (C) 1995, Erik Corry (ehcorry@inet.uni-c.dk)
 */

#ifndef PNM_H_INCLUDED
#define PNM_H_INCLUDED 1

#include "image_format.h"

/*
 * pnmState
 */
typedef struct pnm_state
{
  int state;               /* state of PNM reader */
  FormatLineProc lineProc; /* line callback */
  void *closure;           /* closure for callback */

  Image *image;

  int   pos;               /* current read position */
  int   ypos;              /* current line */
  int   xpos;              /* current pixel */
  byte *imagepos;          /* current posn. in output */
  bool  mac_newlines;      /* CR or LFCR for newlines */
  bool  raw;               /* raw file */
  byte *input_table;
  bool  free_input_table;
  Intensity cmap[3][256]; /* colormap */
  int   max_val;
  int   pnm_class;
  int   width;

} pnmState;

/*
 * state of PNM reader
 */
#define PNM_READ_MAGIC 1
#define PNM_READ_WIDTH 2
#define PNM_READ_HEIGHT 3
#define PNM_READ_MAX_VAL 4
#define PNM_READ_PRE_RAW_NEWLINE 5
#define PNM_READ_RAW 6
#define PNM_READ_ASC 7
#define PNM_READ_ASC_BIT 8
#define PNM_FINISHED 0

/*
 * return values from pnm processing fns
 */
#define PNM_ERROR 0
#define PNM_SUCCESS 1
#define PNM_NEED_DATA 2

#endif
