/*
 * hr.c
 *
 * Copyright (c) 1995, John D. Kilburg (john@cs.unlv.edu)
 *
 * See copyright.h for more information.
 */
#include "copyright.h"

#include <stdio.h>

#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif

#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include "WWWP.h"

/*
 *
 * Private functions
 *
 */

static void RenderHR _ArgProto((WWWWidget, RenderPart *, XEvent *));
static void SetupHR _ArgProto((WWWWidget, RenderPart *, Region, int, int));

/*
 * SetupHR
 */
static void
SetupHR(rw, rp, r, line_y, line_height)
WWWWidget rw;
RenderPart *rp;
Region r;
int line_y;
int line_height;
{
  rp->y = line_height / 2 + line_y;
  rp->renderable = True;
  RenderHR(rw, rp, NULL);

  return;
}

/*
 * RenderHR
 */
static void
RenderHR(rw, rp, xe)
WWWWidget rw;
RenderPart *rp;
XEvent *xe;
{
  XDrawLine(XtDisplay(rw->www.child), XtWindow(rw->www.child), rw->www.gc,
	    rp->x, rp->y, rp->x + rp->width, rp->y);

  return;
}

/*
 *
 * Public Functions
 *
 */

/*
 * HandleHR
 */
void
HandleHR(rw, p, end)
WWWWidget rw;
MLTag *p;
int end;
{
  RenderPart *rp;

  if (end != 0) return;

  AddLineBreak(rw);
  rp = CreateRenderPart(rw, p, SetupHR, RenderHR, NULL, NULL, 0);
  AddRenderPart(rw, rp, RemainingLineWidth(rw), 20);
  AddLineBreak(rw);

  return;
}
